#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>
#include <string.h>
#include "cars.h"
//#include "containers.h"

railroad_car *train[100];
char input_buffer[100];

enum { eng_code = 'E', box_code = 'B', tnk_code = 'T', cab_code = 'C'};
char extract_car_code (char *input_buffer) {return input_buffer[4];}

void do_analysis (ifstream& car_stream){
   int n, car_count;
   for (car_count = 0; car_stream >> input_buffer; ++car_count) {
      if (car_count > 100) { 
         cerr << "Array overflow in train[n]!" << endl;
         exit (0);
         }
      delete train[car_count];
      switch (extract_car_code (input_buffer)) {
         case eng_code: train[car_count] = new engine(input_buffer);  break;
         case box_code: train[car_count] = new box_car(input_buffer); break;
         case tnk_code: train[car_count] = new tank_car(input_buffer);break;
         case cab_code: train[car_count] = new caboose(input_buffer); break;
         default: cerr << "Car code is unknown!" << endl; 
	          exit (0); 
         }
      }
   for (n = 0; n < car_count; ++n) {
      cout << train[n] -> serial_number << "   "
           << train[n] -> short_name () << "   "
           << train[n] -> capacity ()   << endl;
      }
   }

main () { 
while (1) {
   cout << "Please type the name of a train file." << endl << ": ";
   cin  >> input_buffer;
   ifstream car_stream (input_buffer, ios::in);
   if (!car_stream) { cout << "No such file." << endl; return 0;}
   do_analysis (car_stream);
   car_stream.close ();
   }
}